#!/bin/bash
# -*- mode: sh; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# vim: et sts=4 sw=4

#  SPDX-License-Identifier: LGPL-2.1+
#
#  Copyright © 2021 Collabora Ltd.
#  Copyright © 2021 Valve Corporation.
#
#  This file is part of steamos-customizations.
#
#  steamos-customizations is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public License as
#  published by the Free Software Foundation; either version 2.1 of the License,
#  or (at your option) any later version.

get_efivar_str() {
    dd bs=1 skip=4 status=none "if=$1" | iconv -t ASCII -f UTF-16 | tr '\0' '\n'
}

for i in /sys/firmware/efi/efivars/*LoaderDevicePartUUID-*
do
    [[ -e "$i" ]] || continue

    partuuid="$(get_efivar_str /dev/stdin <"$i")"
    [[ "$partuuid" ]] || continue

    partuuid="${partuuid,,}"
    wait_for_dev "/dev/disk/by-partuuid/$partuuid"

    symlink="${i##*/}"
    symlink="${symlink%DevicePartUUID-*}"
    symlink="${symlink,,}"
    cat <<EOF >/etc/udev/rules.d/99-$symlink.rules
ENV{ID_PART_ENTRY_SCHEME}=="gpt", ENV{ID_PART_ENTRY_UUID}=="$partuuid", SYMLINK+="$symlink"
EOF
done
